/*
  ==============================================================================

    jp_utilities.h
    Created: 11 Mar 2020 8:28:27am
    Author:  JP music

  ==============================================================================
*/

#pragma once

#include <JuceHeader.h>


namespace jp {

	struct MyFifo
	{
		void addToFifo(const AudioBuffer<float>* someData, int numItems, int startSample = 0)
		{
			auto writeHandle = abstractFifo.write(numItems);
			if (writeHandle.blockSize1 > 0)
				for (auto j = 0; j < someData->getNumChannels(); ++j)
					myBuffer.copyFrom(j, writeHandle.startIndex1, someData->getReadPointer(j, startSample), writeHandle.blockSize1);

			if (writeHandle.blockSize2 > 0)
				for (auto j = 0; j < someData->getNumChannels(); ++j)
					myBuffer.copyFrom(j, writeHandle.startIndex2, someData->getReadPointer(j, startSample) + writeHandle.blockSize1, writeHandle.blockSize2);
		}

		void readFromFifo(AudioBuffer<float>* someData, int numItems, int startSample = 0)
		{
			auto readHandle = abstractFifo.read(numItems);
			if (readHandle.blockSize1 > 0)
				for (auto j = 0; j < someData->getNumChannels(); ++j)
					someData->copyFrom(j, startSample, myBuffer.getReadPointer(j) + readHandle.startIndex1, readHandle.blockSize1);

			if (readHandle.blockSize2 > 0)
				for (auto j = 0; j < someData->getNumChannels(); ++j)
					someData->copyFrom(j, startSample + readHandle.blockSize1, myBuffer.getReadPointer(j) + readHandle.startIndex2, readHandle.blockSize2);
		}

		AbstractFifo abstractFifo{ 2048 };
		AudioBuffer<float> myBuffer{ 2, 2048 };
	};

} // namespace jp
